import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class MapReduceFilter {
        public static void main(String[] args) {
                System.out.println("------Filter for modulo 2 == 0----------------");
                Stream.of(1,2,3,4,5,6,7,8,9,10)
                .filter(elem -> elem % 2 == 0)
                .forEach(elem -> System.out.println(elem));

                System.out.println("------map (everything x2)----------------");
                List<Integer> numStream = Stream.of(1,2,3,4,5,6,7,8,9,10)
                                                .map(elem -> elem*2)
                                                .collect(Collectors.toList());
                
                numStream.forEach(System.out::println);

                System.out.println("------Reduce (find sum of numbers)-------");
                Integer res = Stream.of(10,20,30,40)
                                        .reduce(0,(elem1,elem2) -> elem1+elem2); 

                System.out.println("Sum result: "+ res);


        }
}
